Global NTGox#
Global NTGoz#
Global NTGpixelwidth#
Global NTGpixelheight#
Global NTGinit = False
Global NTGplane
Global NTGcam
Global NTGheight#
Global NTGrotation#
Global NTGscalex# = 1
Global NTGscaley# = 1
Global NTGalpha# = 1
Global NTGblend = 1
Global NTGBlue = 255
Global NTGGreen = 255
Global NTGRed = 255
Global NTGorder = 0

Type NTGsprite
	Field entity,active,tex,anim
End Type






Function DrawNTG(hand.NTGsprite,x#,y#,frm = 0)

ShowEntity hand\entity
hand\active = True
PositionEntity hand\entity,NTGox# + x#*NTGpixelwidth#,0,NTGoz# + y#*NTGpixelheight
RotateEntity hand\entity,0,NTGrotation#,0
ScaleEntity hand\entity, NTGscalex#,1,NTGscaley#
EntityAlpha hand\entity, NTGalpha#
EntityBlend hand\entity, NTGblend
EntityColor hand\entity, NTGRed, NTGGreen, NTGBlue

If hand\anim = True Then
	EntityTexture hand\entity,hand\tex,frm
EndIf

EntityOrder hand\entity,NTGorder
NTGorder = NTGorder - 1

End Function


Function UpdateNTG()

For s.NTGsprite = Each NTGsprite
	s\active = False
	HideEntity s\entity
Next

NTGorder = 0

End Function

Function NTGsetcolor(r,g,b)

NTGred = r
NTGgreen = g
NTGblue = b

End Function

Function NTGSetBlend(bld)
	NTGblend = bld
End Function

Function NTGSetRotation(Rot# = 0)
	NTGrotation = rot#
End Function

Function NTGsetscale(sclx# = 1,scly# = 1)
	NTGscalex# = sclx#
	NTGscaley# = scly#
End Function

Function NTGsetalpha(alph# = 1)
	NTGalpha# = alph#
End Function








Function NTGCreateRect.NTGsprite(width#,height#,r = 255,g = 255,b = 255)

tmptex = CreateTexture(64,64)
SetBuffer TextureBuffer(tmptex)

Color r,g,b
Rect 0,0,65,65,1

SetBuffer BackBuffer()

tmp.NTGsprite = New NTGsprite
tmp\entity = CreateMesh()
EntityFX tmp\entity,1

tmpsurf = CreateSurface(tmp\entity)
width# = width# / 2
height# = height# / 2
v1 = AddVertex(tmpsurf,0-(width#*NTGpixelwidth),NTGheight#,0-(height#*NTGpixelheight#),0,0)
v2 = AddVertex(tmpsurf,(width#*NTGpixelwidth),NTGheight#,0-(height#*NTGpixelheight#),1,0)
v3 = AddVertex(tmpsurf,(width#*NTGpixelwidth),NTGheight#,(height#*NTGpixelheight#),1,1)
v4 = AddVertex(tmpsurf,0-(width#*NTGpixelwidth),NTGheight#,(height#*NTGpixelheight#),0,1)


AddTriangle(tmpsurf,v3,v4,v2)
AddTriangle(tmpsurf,v2,v4,v1)

;EntityColor tmp\entity,r,g,b

UpdateNormals tmp\entity

EntityTexture tmp\entity, tmptex
tmp\tex = tmptex

HideEntity tmp\entity

Return tmp.NTGsprite

End Function













Function NTGLoadImage.NTGsprite(imageext$)

tmpimg = LoadImage(imageext$)
width# = ImageWidth(tmpimg)
height# = ImageHeight(tmpimg)

tmptex = LoadBrush(imageext$,4);LoadTexture(imageext$,4)

tmp.NTGsprite = New NTGsprite
tmp\entity = CreateMesh()
EntityFX tmp\entity,1
tmp\tex = tmptex
tmpsurf = CreateSurface(tmp\entity)
width# = width# / 2
height# = height# / 2
v1 = AddVertex(tmpsurf,0-(width#*NTGpixelwidth),NTGheight#,0-(height#*NTGpixelheight#),0,0)
v2 = AddVertex(tmpsurf,(width#*NTGpixelwidth),NTGheight#,0-(height#*NTGpixelheight#),1,0)
v3 = AddVertex(tmpsurf,(width#*NTGpixelwidth),NTGheight#,(height#*NTGpixelheight#),1,1)
v4 = AddVertex(tmpsurf,0-(width#*NTGpixelwidth),NTGheight#,(height#*NTGpixelheight#),0,1)


AddTriangle(tmpsurf,v3,v4,v2)
AddTriangle(tmpsurf,v2,v4,v1)

;EntityColor tmp\entity,r,g,b

UpdateNormals tmp\entity

PaintSurface tmpsurf,tmptex
;EntityTexture tmp\entity, tmptex

HideEntity tmp\entity

Return tmp.NTGsprite



End Function










Function NTGLoadAnimImage.NTGsprite(imageext$,w,h,f,c)

tmpimg = LoadImage(imageext$)
width# = ImageWidth(tmpimg)
height# = ImageHeight(tmpimg)


tmptex = LoadAnimTexture(imageext$,4,w,h,f,c)

tmp.NTGsprite = New NTGsprite
tmp\entity = CreateMesh()
EntityFX tmp\entity,1
tmp\tex = tmptex

tmp\anim = True

tmpsurf = CreateSurface(tmp\entity)
width# = width# / 2
height# = height# / 2
v1 = AddVertex(tmpsurf,0-(width#*NTGpixelwidth),NTGheight#,0-(height#*NTGpixelheight#),0,0)
v2 = AddVertex(tmpsurf,(width#*NTGpixelwidth),NTGheight#,0-(height#*NTGpixelheight#),1,0)
v3 = AddVertex(tmpsurf,(width#*NTGpixelwidth),NTGheight#,(height#*NTGpixelheight#),1,1)
v4 = AddVertex(tmpsurf,0-(width#*NTGpixelwidth),NTGheight#,(height#*NTGpixelheight#),0,1)


AddTriangle(tmpsurf,v3,v4,v2)
AddTriangle(tmpsurf,v2,v4,v1)

;EntityColor tmp\entity,r,g,b

UpdateNormals tmp\entity

EntityTexture tmp\entity, tmptex

HideEntity tmp\entity

Return tmp.NTGsprite



End Function











Function NTGinit2d(maxrng# = 1000)

NTGcam = CreateCamera()
NTGinit = True

If NTGcam = 0 Then RuntimeError("Camera does not exist.")

NTGplane = CreatePlane()

TurnEntity NTGplane,-90,0,0
MoveEntity NTGplane,0,-2,0
EntityParent NTGplane,NTGcam
EntityAlpha NTGplane,0
EntityPickMode NTGplane,2

CameraRange NTGcam,.01,maxrng#
TurnEntity NTGcam,90,0,0
MoveEntity NTGcam,0,-5,100
CameraZoom NTGcam,3
CameraClsMode NTGcam,0,1

CameraPick NTGcam,1,1

x1# = PickedX()
z1# = PickedZ()
NTGheight# = PickedY()

CameraPick NTGcam,GraphicsWidth(),GraphicsHeight()

x2# = PickedX()
z2# = PickedZ()


NTGox# = x1#
NTGoz# = z1#

NTGpixelwidth# = (x2#-x1#)/GraphicsWidth()
NTGpixelheight# = (z2#-z1#)/GraphicsHeight()


;lit = CreateLight(3)

;MoveEntity lit,0,-101,0
;TurnEntity lit,90,0,0

End Function






Function EndNTG()

For n.NTGsprite = Each NTGsprite
	FreeEntity n\entity
	Delete n.NTGsprite
Next

End Function






Function ScaleImageFast(SrcImage, ScaleX#, ScaleY#, ExactSize=False)

	Local SrcWidth,  SrcHeight
	Local DestWidth, DestHeight
	Local ScratchImage, DestImage
	Local SrcBuffer, ScratchBuffer, DestBuffer
	Local X1, Y1, X2, Y2
	
	; Get the width and height of the source image. 	
		SrcWidth  = ImageWidth(SrcImage)
		SrcHeight = ImageHeight(SrcImage)

	; Calculate the width and height of the dest image, or the scale.
		If ExactSize = False
	
			DestWidth  = Floor(SrcWidth  * ScaleX#)
			DestHeight = Floor(SrcHeight * ScaleY#)
	
		Else
	
			DestWidth  = ScaleX#
			DestHeight = ScaleY#

			ScaleX# = Float(DestWidth)  / Float(SrcWidth)
			ScaleY# = Float(DestHeight) / Float(SrcHeight)
	
		EndIf			

	; If the image does not need to be scaled, just copy the image and exit the function.
		If (SrcWidth = DestWidth) And (SrcHeight = DestHeight) Then Return CopyImage(SrcImage)

	; Create a scratch image that is as tall as the source image, and as wide as the destination image.
		ScratchImage = CreateImage(DestWidth, SrcHeight)
				
	; Create the destination image.
		DestImage = CreateImage(DestWidth, DestHeight) 

	; Get pointers to the image buffers.
		SrcBuffer     = ImageBuffer(SrcImage)
		ScratchBuffer = ImageBuffer(ScratchImage)
		DestBuffer    = ImageBuffer(DestImage)

	; Duplicate columns from source image to scratch image.
		For X2 = 0 To DestWidth-1
			X1 = Floor(X2 / ScaleX#)
			CopyRect X1, 0, 1, SrcHeight, X2, 0, SrcBuffer, ScratchBuffer
		Next
			
	; Duplicate rows from scratch image to destination image.
		For Y2 = 0 To DestHeight-1
			Y1 = Floor(Y2 / ScaleY#)
			CopyRect 0, Y1, DestWidth, 1, 0, Y2, ScratchBuffer, DestBuffer
		Next
						
	; Free the scratch image.
		FreeImage ScratchImage					
						
	; Return the new image.
		Return DestImage
					
End Function






Function NTGdelete(tmp.NTGsprite)

FreeEntity tmp\entity
Delete tmp.NTGsprite

End Function